<?
require_once('includes/common.php');
require_once('includes/Payment.php');
require_once('includes/CompanyTransaction.php');
require_once('includes/'.$GLOBALS['cc_processor']['class_name'].'.php');
checkLogin();
if($loggedin_user->hasRight('accounting') && !empty($_REQUEST['id'])){
	$company_id = $_REQUEST['id'];
}else{
	$company_id = $loggedin_user->company_id;
}

$invoice = new Invoice();
if($invoice->get($_REQUEST['invoice_id']) === FALSE){
	fatal_error("Could not get invoice {$_REQUEST['invoice_id']}\n");	
}

$payment = new Payment();
$payment->company_id = $company_id;
$title = "Add Payment";

if($_POST['save']){
	$payment->amount = preg_replace('/[^0-9\.]/','', $_POST['amount']);
	if($payment->amount > $invoice->getTotal()){
		fatal_error("Amount can not be more than amount due on the invoice!\n");	
	}
	$payment->timestamp = time();
	$payment->type = 'CC';
	
	// Process the card
	$cc_processor = new $GLOBALS['cc_processor']['class_name']($GLOBALS['cc_processor']['username'],$GLOBALS['cc_processor']['password'],$GLOBALS['cc_processor']['testmode']);
	if($cc_processor->setAddress($company_id, $_POST['card_first_name'], $_POST['card_last_name'], '', $_POST['card_address'], $_POST['card_city'], $_POST['card_state'], $_POST['card_zip']) === FALSE){
		fatal_error('Error processing card: '.$cc_processor->getLastError());	
	}
	if($cc_processor->setCC($_POST['card_number'], $_POST['card_exp_month'].$_POST['card_exp_year'], $payment->amount) === FALSE){
		fatal_error('Error processing card: '.$cc_processor->getLastError());	
	}
	$cc_result = $cc_processor->process();
	if($cc_result != 1){
		fatal_error('Error processing card: '.$cc_processor->getLastError());	
	}
	
	if($payment->add()){
		//TODO: Attach to oldest invoices
		if($payment->attachInvoices(array($_POST['invoice_id'] => $payment->amount)) === FALSE){
			$error_msg .= "Error applying payment to invoice!\n";
			debug_message($payment->getLastError());
		}

		// Add the company transaction
		$ct = new CompanyTransaction();
		$ct->amount = -$payment->amount;
		$ct->company_id = $payment->company_id;
		$ct->description = "Credit card payment of ".$payment->amount." on ".date("n/j/y", $payment->timestamp);
		$ct->timestamp = time();
		if($ct->add() === FALSE){
			$error_msg .= "Error adding transaction to company account!\n";
			debug_message($ct->getLastError());
		}

		// Update the payment with the company transaction id
		$payment->trans_id = $ct->id;
		if($payment->update() === FALSE){
			$error_msg .= "Error updating payment with company transaction id!\n";
			debug_message($payment->getLastError());
		}

		if(empty($error_msg)){
			goBack();
		}
	}else{
		$error_msg .= "Error adding Payment!\n";
		debug_message($payment->getLastError());
	}
}

?>
<? require('header.php'); ?>
<FORM ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="POST" NAME="chk">
<input type="hidden" name="invoice_id" value="<?= $_REQUEST['invoice_id'] ?>">
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Date:</TD>
	<TD CLASS="form_field_cell"><?= date('n/j/y'); ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Company:</TD>
	<TD CLASS="form_field_cell"><?= Company::getName($payment->company_id) ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Invoice:</TD>
	<TD CLASS="form_field_cell"><?= $invoice->id ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Amount:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="amount" CLASS="input_text" SIZE="10" TYPE="text" VALUE="<?= number_format($invoice->getTotal(),2) ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">First Name:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="card_first_name" CLASS="input_text" SIZE="20" TYPE="text" VALUE="<?= $loggedin_user->first_name ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Last Name:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="card_last_name" CLASS="input_text" SIZE="20" TYPE="text" VALUE="<?= $loggedin_user->last_name ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Billing Address:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="card_address" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $loggedin_user->address1 ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Billing City:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="card_city" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $loggedin_user->city ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Billing State:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="card_state" CLASS="input_text" SIZE="5" TYPE="text" VALUE="<?= $loggedin_user->state ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Billing Zip:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="card_zip" CLASS="input_text" SIZE="10" TYPE="text" VALUE="<?= $loggedin_user->zip ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Card Number:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="card_number" CLASS="input_text" SIZE="25" TYPE="text"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Expiration:</TD>
	<TD CLASS="form_field_cell">
		<select name="card_exp_month">
			<option value="01">01 (Jan)</option>
			<option value="02">02 (Feb)</option>
			<option value="03">03 (Mar)</option>
			<option value="04">04 (Apr)</option>
			<option value="05">05 (May)</option>
			<option value="06">06 (Jun)</option>
			<option value="07">07 (Jul)</option>
			<option value="08">08 (Aug)</option>
			<option value="09">09 (Sep)</option>
			<option value="10">10 (Oct)</option>
			<option value="11">11 (Nov)</option>
			<option value="12">12 (Dec)</option>
		</select>
		<select name="card_exp_year">
			<option value="05">2005</option>
			<option value="06">2006</option>
			<option value="07">2007</option>
			<option value="08">2008</option>
			<option value="09">2009</option>
			<option value="10">2010</option>
			<option value="11">2011</option>
			<option value="12">2012</option>
			<option value="13">2013</option>
			<option value="14">2014</option>
			<option value="15">2015</option>
			<option value="16">2016</option>
			<option value="17">2017</option>
		</select>
	</TD>
</TR>
<TR>
	<TD COLSPAN="2" CLASS="form_field_cell">
		<DIV ALIGN="right"><INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Process Payment"></DIV>
	</TD>
</TR>	
</TABLE>
</FORM>
<? require('footer.php'); ?>