<?
require_once('includes/common.php');
require_once('includes/Project.php');
require_once('includes/Company.php');
require_once('includes/Invoice.php');

checkLogin();
$project = new Project();
if($loggedin_user->isDeveloper() && !empty($_REQUEST['id'])){
	$id = $_REQUEST['id'];
}else{
	$id = $loggedin_user->company_id;
}

$company = new Company();
if($company->get($id) === FALSE){
	$error_msg .= "Could not retrieve data for company!\n";
	debug_message($company->getLastError());
}

$balance = $company->getBalance();
if($balance === FALSE){
	$error_msg .= "Error getting your outstanding balance!";
	debug_message($company->getLastError());
}

$transactions = $company->getTransactions(NULL, 5);
if($transactions === FALSE){
	$error_msg .= "Error getting transactions for company!\n";
	debug_message($company->getLastError());
}

$invoice = new Invoice();
$invoices = $invoice->getOutstanding($company->id);
if($invoices === FALSE){
	$error_msg .= "Could not retrieve Outstanding Invoice list!\n";
	debug_message($invoice->getLastError());
}

$project = new Project();
$projects = $project->getCompanyProjects($company->id);
if($projects === FALSE){
	$error_msg .= "Could not retrieve active project list!\n";
	debug_message($project->getLastError());
}


$title = $company->name." Detail Center";
if($loggedin_user->hasRight('admin')){
	$update_url = "company.php?mode=edit&id=$id";
}else{
	$update_url = "company_profile.php?id=$id";
}
require('header.php'); ?>
<SCRIPT>
function reloadPage(selObj){
	var user_id = selObj.options[selObj.selectedIndex].value;
	window.location.href = "<?= $_SERVER['PHP_SELF'] ?>?filter=<?= $_REQUEST['filter'] ?>&user_id="+user_id;
}
</SCRIPT>
<TABLE BORDER="0" CELLSPACING="4" CELLPADDING="0">
<TR>
	<TD VALIGN="top" ALIGN="LEFT">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table" WIDTH="200">
			<TR>
				<TD COLSPAN="2" CLASS="form_header_cell">Company Information</TD>
			</TR>
			<TR>
				<TD CLASS="form_field_cell" COLSPAN="2">
					<B><?= $company->name ?></B><BR>
					<?= $company->address1.( !empty($company->address2) ? '<BR>'.$company->address2 : '' )?><BR>
					<?= $company->city.', '.$company->state.'   '.$company->zip ?>
					<DIV ALIGN="right"><A HREF="<?= $update_url ?>">Update</A></DIV>
				</TD>
			</TR>
		</TABLE>
	</TD>
	<TD VALIGN="top" ALIGN="LEFT">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
			<TR>
				<TD COLSPAN="2" CLASS="form_header_cell">Outstanding Invoices</TD>
			</TR>
<?	if(count($invoices) > 0){?>
			<TR>
				<TD CLASS="form_field_cell" COLSPAN="2">
					<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0">
<?	for($i=0; $i<count($invoices); $i++){
			$total += $invoices[$i]->getTotal(); ?>
					<TR>
						<TD><A title="View Invoice" HREF="invoice_view.php?id=<?= $invoices[$i]->id ?>"><?= $invoices[$i]->id ?></A>&nbsp;</TD>
						<TD ALIGN="right">&nbsp;&nbsp;<?= date("n/j/y", $invoices[$i]->timestamp) ?></TD>
						<TD ALIGN="right">&nbsp;&nbsp;$<?= number_format($invoices[$i]->getTotal(),2) ?></TD>
						<TD ALIGN="right">&nbsp;&nbsp;
							<A CLASS="link1" HREF="invoice_view.php?id=<?= $invoices[$i]->id ?>"><img src="images/properties.gif" width="16" height="16" title="View Invoice" border="0" /></A>
							<A CLASS="link1" HREF="invoice_pdf.php?id=<?= $invoices[$i]->id ?>"><img target="invoice_window" src="images/acrobat.gif" width="15" height="16" title="View Invoice PDF" border="0" /></A>
							<A HREF="cc_payment.php?invoice_id=<?= $invoices[$i]->id ?>"><img src="images/payment.png" border="0" width="16" height="16" title="Make Payment"></A>
						</TD>
					</TR>
<?	}?>
					</TABLE>
				</TD>
			</TR>
			<TR>
				<TD CLASS="form_field_header_cell">Total:</TD>
				<TD CLASS="form_field_cell" ALIGN="right">$<?= number_format($total, 2) ?></TD>
			</TR>
<?	}else{ // if invoices > 0 ?>
			<TR>
				<TD COLSPAN="2" CLASS="form_field_cell">None</TD>
			</TR>

<?	} // if invoices > 0  
?>
		</TABLE>
	</TD>
</TR>
<TR>
	<TD VALIGN="top" COLSPAN="2" ALIGN="LEFT">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table" WIDTH="100%">
			<TR>
				<TD COLSPAN="5" CLASS="form_header_cell">Active Projects</TD>
			</TR>
			<TR>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 0, 1, false)">Project</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 2, 0, false)">Status</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 3, 0, false)">Due Date</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 4, 0, false)">Priority</A></TD>
			</TR>
			<TBODY ID="bodyId1">
		<? for($i = 0; $i < count($projects); $i++){ ?>
			<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
				<TD CLASS="dg_data_cell_1"><A title="Project Details" HREF="project_details.php?id=<?= $projects[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><?= $projects[$i]->name ?></A></TD>
				<TD CLASS="dg_data_cell_1"><?= $projects[$i]->status ?></TD>
				<TD CLASS="dg_data_cell_1"><?=  $projects[$i]->due_ts>0 ? date("n/j/y", $projects[$i]->due_ts) : "None" ?></TD>
				<TD CLASS="dg_data_cell_1"><?= $projects[$i]->priority ?></TD>
			</TR>
		<? }?>
		</TBODY>
		</TABLE>
	</TD>
</TR>
</TABLE>
<? require('footer.php') ?>
