<?
require_once("Invoice.php");
require_once('Expense.php');
require_once("CompanyTransaction.php");


////////////////////////////////////////////////////////////
// Code generated by CodeGen (http://uversaconsulting.net).
// Insert custom code where indicated below.
////////////////////////////////////////////////////////////

// Company Class Definition 
////////////////////////////////////////////////////////////
class Company{
	var $id, $name, $address1, $address2, 
	  $city, $state, $zip, $phone, 
		$fax, $hourly_rate, $created_ts, $updated_ts;

	var $error;

	function Company(){
		$this->error = '';
		$this->id = 0;
		$this->name = '';
		$this->address1 = '';
		$this->address2 = '';
		$this->city = '';
		$this->state = '';
		$this->zip = '';
		$this->phone = '';
		$this->fax = '';
		$this->hourly_rate = 0.00;
		$this->created_ts = 0;
		$this->updated_ts = 0;

	}

	function _populateData($values){
		if(is_array($values)){
			$this->id = $values[0];
			$this->name = $values[1];
			$this->address1 = $values[2];
			$this->address2 = $values[3];
			$this->city = $values[4];
			$this->state = $values[5];
			$this->zip = $values[6];
			$this->phone = $values[7];
			$this->fax = $values[8];
			$this->hourly_rate = $values[9];
			$this->created_ts = $values[10];
			$this->updated_ts = $values[11];
		}
	}

	function updateFromAssocArray($array){
		if(is_array($array)){
			foreach($array as $key => $value)
				$this->$key = $value;
		}
	}

	function escapeStrings(){
		global $db_conn;
		
		$vars = get_object_vars($this);
		foreach($vars as $key => $value){
			if(is_string($value)){
				$this->$key = $db_conn->escapeString($value);
			}
		}
	}

	function stripSlashes(){
		$vars = get_object_vars($this);
		foreach($vars as $key => $value){
			if(is_string($value)){
				$this->$key = stripcslashes($value);
			}
		}
	}

	function getLastError(){
		return $this->error;
	}

	function add(){
		global $db_conn;

		$this->escapeStrings();
		$result = $db_conn->query("INSERT INTO companies (name, address1, address2, city, ".
			"state, zip, phone, fax, hourly_rate, ".
		  "created_ts, updated_ts)".
			" VALUES('".$this->name."', '".$this->address1."', '".$this->address2."', '".$this->city."', ".
			"'".$this->state."', '".$this->zip."', '".$this->phone."', '".$this->fax."', ".$this->hourly_rate.", ".
		  "UNIX_TIMESTAMP(), ".$this->updated_ts.")");
		$this->stripSlashes();
		if($result){
			$this->id = mysql_insert_id();
			return TRUE;
		}else{
			$this->error = "Company::add() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function update(){
		global $db_conn;

		if(!isset($this->id)){
			$this->error = "Company::update() : Company id not set\n";
			return FALSE;
		}

		$this->escapeStrings();
		$result = $db_conn->query("UPDATE companies SET name = '".$this->name."', ".
		  "address1 = '".$this->address1."', address2 = '".$this->address2."', ".
		  "city = '".$this->city."', state = '".$this->state."', ".
		  "zip = '".$this->zip."', phone = '".$this->phone."', ".
			"fax = '".$this->fax."', hourly_rate = '".$this->hourly_rate."', created_ts = ".$this->created_ts.", ".
		  "updated_ts = UNIX_TIMESTAMP()".
		  " WHERE id = ".$this->id."");
		$this->stripSlashes();
		if($result){
			return TRUE;
		}else{
			$this->error = "Company::update() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function delete($id = NULL){
		global $db_conn;

		if(!isset($id)){
			$id = $this->id;
		}

		if(!isset($id)){
			$this->error = "Company::delete() : Company id not set\n";
			return FALSE;
		}

		$result = $db_conn->query("DELETE FROM companies WHERE id = $id");

		if($result){
			return TRUE;
		}else{
			$this->error = "Company::delete() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function get($id = NULL){
		global $db_conn;

		if(!isset($id)){
			$id = $this->id;
		}

		if(!isset($id)){
			$this->error = "Company::get() : Company id not set\n";
			return FALSE;
		}

		$Company = Company::retrieveSet("WHERE id = $id", TRUE);
		if($Company === FALSE){
			return FALSE;
		}

		if(isset($Company[0])){
			$this->_populateData($Company[0]);
		}else{
			$this->error = "Company::get() : No data retrieved from query\n";
			return FALSE;
		}
		return TRUE;
	}

	function retrieveSet($clause = '', $raw = FALSE){
		global $db_conn;

		if(!empty($clause)){
			$clause = trim($clause);
			if(strlen($clause) > 5){
				if(strtolower(substr($clause, 0, 5)) != "where" && strtolower(substr($clause, 0, 5)) != "order")
					$clause = "WHERE ".$clause;
			}else{
				$clause = "WHERE ".$clause;
			}
		}

		$result = $db_conn->query("SELECT  id, name, address1, address2, city, state, ".
			"zip, phone, fax, hourly_rate, created_ts, updated_ts".
		  " FROM companies ".$clause);

		if(!$result){
			$this->error = "Company::retrieveSet(): ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		while($row=$result->fetchRow()){
			if($raw == TRUE){
				$Company[] = $row;
			}else{
				$temp =& new Company();
				$temp->_populateData($row);
				$Company[] =& $temp;
			}
		}
		$result->free();

		return $Company;
	}
// BEGIN - Custom Company methods 
////////////////////////////////////////////////////////////
	function getCompanysWithBalance(){
		global $db_conn;

		$result = $db_conn->query("SELECT c.id, c.name, c.address1, c.address2, c.city, c.state,
c.zip, c.phone, c.fax, c.hourly_rate, c.created_ts, c.updated_ts, SUM(ct.amount) as price
FROM company_transactions AS ct
LEFT JOIN companies AS c ON ct.company_id = c.id
GROUP BY c.id HAVING price > 0");

		if(!$result){
			$this->error = "Company::getCompanysWithBalance(): ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		while($row=$result->fetchRow()){
			$temp =& new Company();
			$temp->_populateData($row);
			$temp->price = $row[12];
			$Company[] =& $temp;
		}

		return $Company;
	}

	function getCompanysWithUnbilledAmount(){
		global $db_conn;

		$result = $db_conn->query("SELECT c.id, c.name, c.address1, c.address2, c.city, c.state,
c.zip, c.phone, c.fax, c.hourly_rate, c.created_ts, c.updated_ts, SUM(end_ts - start_ts) as time_spent, 
SUM(ROUND((((ta.end_ts - ta.start_ts) / 60 / 60) * ta.hourly_rate), 2)) AS amount
FROM task_activities AS ta
LEFT JOIN tasks AS t ON ta.task_id = t.id
LEFT JOIN projects AS p ON t.project_id = p.id
LEFT JOIN companies AS c ON p.company_id = c.id
LEFT JOIN invoice_line_links AS ill ON ta.id = ill.task_activity_id
WHERE ill.invoice_line_id IS NULL AND ((p.billable = 'Y' AND t.billable = 'D' )OR t.billable = 'Y')
GROUP BY c.id
HAVING amount > 0");

		if(!$result){
			$this->error = "Company::getCompanysWithBalance(): ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		while($row=$result->fetchArray(MYSQL_ASSOC)){
			$temp =& new Company();
			$temp->updateFromAssocArray($row);
			$Company[] =& $temp;
		}

		return $Company;
	}

	function getInvoices(){
		global $db_conn;

		$invoice = new Invoice();
		$invoices = $invoice->retrieveSet("WHERE company_id = {$this->id} ORDER BY timestamp DESC");
		if($invoices === FALSE){
			$this->error = "Company::getInvoices(): Error getting invoices: ".$invoice->getLastError();
    		return FALSE;
    	}
	
	    return $invoices;
	}

	function getSelectTags($selected = NULL){
		global $db_conn;

		$result = $db_conn->query("SELECT id, name FROM companies ORDER BY name");

		if($result === FALSE){
			$this->error = "Company::getSelectTags(): ".$db_conn->getLastError()."\n";
			return FALSE;
		}


		while($row=$result->fetchRow()){
			$sel_text = "";
			if($row[0]==$selected)
				$sel_text = " SELECTED";
			$tags .= "<OPTION VALUE=\"".$row[0]."\"".$sel_text.">".$row[1]."</OPTION>\n";
		}
		return $tags;
	}

	function getBalance($id = NULL){
		global $db_conn;

		if($id === NULL){
			$id = $this->id;
		}

		$ct = new CompanyTransaction();
		$amount = $ct->getBalance($id);
		if($amount === FALSE){
			$this->error = "Company::getBalance(): Error getting balance: ".$ct->getLastError();
			return FALSE;
		}

		return $amount;
	}

	function getTransactions($id = NULL, $limit = 0){
		global $db_conn;

		if($id === NULL){
			$id = $this->id;
		}

		$ct = new CompanyTransaction();
		$result = $ct->getTransactions($id, $limit);
		if($result === FALSE){
			$this->error = "Company::getTransactions(): Error getting transactions: ".$ct->getLastError();
			return FALSE;
		}

		return $result;
	}

	function getName($company_id = NULL){
		global $db_conn;

		if($company_id === NULL){
			$company_id = $this->id;
		}

		$company_id = intval($company_id);
		if($company_id <= 0){
			$this->error = "Company::getName() : Invalid company id!\n";
			return FALSE;
		}

		$result = $db_conn->query("SELECT name FROM companies WHERE id = $company_id");
		if($result === FALSE){
			$this->error = "Company::getName() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		$name = '';
		if($row = $result->fetchArray(MYSQL_ASSOC)){
			$name = $row['name'];
		}

		return $name;
	}

	function getExpenses($unbilled = FALSE){
		$exp = new Expense();
		$expenses = $exp->getForCompany($this->id, $unbilled);
		if($expenses === FALSE){
			$this->error = "Project::getExpenses(): " . $exp->getLastError();
			return FALSE;
		}
		
		return $expenses;
	}

	function getInvoiceEmails(){
		global $db_conn;
		
		if($this->id <= 0)
			return array();
			
		$sql = "SELECT first_name, last_name, email FROM users WHERE invoiced = 'Y' AND company_id = ".$this->id;
		$result = $db_conn->query($sql);
		if($result === FALSE){
			$this->error = "Company::getInvoiceEmails(): Error getting emails: ".$db_conn->getLastError();
			return FALSE;
		}
		
		$emails = array();
		while($row = $result->fetchArray(MYSQL_ASSOC)){
			$emails[] = $row['first_name'].' '.$row['last_name'].' <'.$row['email'].'>';
		}
		
		return $emails;
	}
// END - Custom Company methods
////////////////////////////////////////////////////////////
}

