<?
require_once('InvoiceLine.php');
require_once('Company.php');
require_once('CompanyTransaction.php');
require_once('TaskActivity.php');
require_once('PaymentSchedule.php');
require_once('Expense.php');
require_once('PDFInvoice.php');


////////////////////////////////////////////////////////////
// Code generated by CodeGen (http://uversaconsulting.net).
// Insert custom code where indicated below.
////////////////////////////////////////////////////////////

// Invoice Class Definition 
////////////////////////////////////////////////////////////
class Invoice{
	var $id, $company_id, $address1, $address2, 
		$city, $state, $zip, $timestamp,
		$terms, $trans_id, $sent_ts;

	var $error;

	var $_lines;

	function Invoice(){
		$this->error = '';
		$this->id = 0;
		$this->company_id = 0;
		$this->address1 = '';
		$this->address2 = '';
		$this->city = '';
		$this->state = '';
		$this->zip = '';
		$this->timestamp = 0;
		$this->terms = '';
		$this->trans_id = 0;
		$this->sent_ts = 0;
		
		$this->_lines = NULL;
	}

	function _populateData($values){
		if(is_array($values)){
			$this->id = $values[0];
			$this->company_id = $values[1];
			$this->address1 = $values[2];
			$this->address2 = $values[3];
			$this->city = $values[4];
			$this->state = $values[5];
			$this->zip = $values[6];
			$this->timestamp = $values[7];
			$this->terms = $values[8];
			$this->trans_id = $values[9];
			$this->sent_ts = $values[10];
		}
	}

	function updateFromAssocArray($array){
		if(isset($array['id'])) $this->id = $array['id'];
		if(isset($array['company_id'])) $this->company_id = $array['company_id'];
		if(isset($array['address1'])) $this->address1 = $array['address1'];
		if(isset($array['address2'])) $this->address2 = $array['address2'];
		if(isset($array['city'])) $this->city = $array['city'];
		if(isset($array['state'])) $this->state = $array['state'];
		if(isset($array['zip'])) $this->zip = $array['zip'];
		if(isset($array['timestamp'])) $this->timestamp = $array['timestamp'];
		if(isset($array['terms'])) $this->terms = $array['terms'];
		if(isset($array['trans_id'])) $this->trans_id = $array['trans_id'];
	}

	function escapeStrings(){
		global $db_conn;
		
		$vars = get_object_vars($this);
		foreach($vars as $key => $value){
			if(is_string($value)){
				$this->$key = $db_conn->escapeString($value);
			}
		}
	}

	function stripSlashes(){
		$vars = get_object_vars($this);
		foreach($vars as $key => $value){
			if(is_string($value)){
				$this->$key = stripcslashes($value);
			}
		}
	}

	function getLastError(){
		return $this->error;
	}

	function add(){
		global $db_conn;

		$this->timestamp = time();
    
		$this->escapeStrings();
		$result = $db_conn->query("INSERT INTO invoices (company_id, address1, address2, city, ".
		  "state, zip, timestamp, terms, ".
		  "trans_id, sent_ts)".
		  " VALUES(".$this->company_id.", '".$this->address1."', '".$this->address2."', '".$this->city."', ".
		  "'".$this->state."', '".$this->zip."', ".$this->timestamp.", '".$this->terms."', ".
		  "".$this->trans_id.", ".$this->sent_ts.")");
		$this->stripSlashes();
		if($result){
			$this->id = mysql_insert_id($db_conn->_conn);
			return TRUE;
		}else{
			$this->error = "Invoice::add() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function update(){
		global $db_conn;

		if(!isset($this->id)){
			$this->error = "Invoice::update() : Invoice id not set\n";
			return FALSE;
		}

		$this->escapeStrings();
		$result = $db_conn->query("UPDATE invoices SET company_id = ".$this->company_id.", ".
		  "address1 = '".$this->address1."', address2 = '".$this->address2."', ".
		  "city = '".$this->city."', state = '".$this->state."', ".
		  "zip = '".$this->zip."', timestamp = ".$this->timestamp.", ".
		  "terms = '".$this->terms."', trans_id = ".$this->trans_id.", sent_ts = ".$this->sent_ts."".
		  " WHERE id = ".$this->id."");
		$this->stripSlashes();
		if($result){
			return TRUE;
		}else{
			$this->error = "Invoice::update() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function delete($id = NULL){
		global $db_conn;

		if(!isset($id)){
			$id = $this->id;
		}

		if(!isset($id)){
			$this->error = "Invoice::delete() : Invoice id not set\n";
			return FALSE;
		}

		$result = $db_conn->query("DELETE FROM invoices WHERE id = $id");

		if($result){
			return TRUE;
		}else{
			$this->error = "Invoice::delete() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function get($id = NULL){
		global $db_conn;

		if(!isset($id)){
			$id = $this->id;
		}

		if(!isset($id)){
			$this->error = "Invoice::get() : Invoice id not set\n";
			return FALSE;
		}

		$Invoice = Invoice::retrieveSet("WHERE id = $id", TRUE);
		if($Invoice === FALSE){
			return FALSE;
		}

		if(isset($Invoice[0])){
			$this->_populateData($Invoice[0]);
			if($this->_populateLines() === FALSE)
				return FALSE;
			$this->stripSlashes();
		}else{
			$this->error = "Invoice::get() : No data retrieved from query\n";
			return FALSE;
		}
		return TRUE;
	}

	function retrieveSet($clause = '', $raw = FALSE){
		global $db_conn;

		if(!empty($clause)){
			$clause = trim($clause);
			if(strlen($clause) > 5){
				if(strtolower(substr($clause, 0, 5)) != "where" && strtolower(substr($clause, 0, 5)) != "order")
					$clause = "WHERE ".$clause;
			}else{
				$clause = "WHERE ".$clause;
			}
		}

		$result = $db_conn->query("SELECT  id, company_id, address1, address2, city, state, ".
			"zip, timestamp, terms, trans_id, sent_ts".
			" FROM invoices ".$clause);

		if(!$result){
			$this->error = "Invoice::retrieveSet(): ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		while($row=$result->fetchRow()){
			if($raw == TRUE){
				$Invoice[] = $row;
			}else{
				$temp =& new Invoice();
				$temp->_populateData($row);
				if($temp->_populateLines() === FALSE)
					return FALSE;
				$temp->stripSlashes();
				$Invoice[] =& $temp;
			}

		}

		return $Invoice;
	}
// BEGIN - Custom Invoice methods
////////////////////////////////////////////////////////////
	function _populateLines(){
		$il = new InvoiceLine();
		$result = $il->getInvoiceLines($this->id);
		if($result === FALSE){
			$this->error = "Invoice::_populateLines(): Error getting invoice lines: ".$il->getLastError()."\n";
			return FALSE;
		}

		$this->_lines = $result;
		return TRUE;
	}

	function getTermsSelectTags($selected = NULL){
		$tags = "";

		$options = array( 'NET15' => 'NET15', 'NET30' => 'NET30', 'NET45' => 'NET45' );

		foreach($options as $value => $name){
			$sel_text = "";
			if($value==$selected)
				$sel_text = " SELECTED";

			$tags .= "<OPTION VALUE=\"".$value."\"".$sel_text.">".$name." ".$row[2]."</OPTION>\n";
		}
		return $tags;
	}

	function addTaskActivities($ta_ids){
		if(!is_array($ta_ids) || count($ta_ids) <= 0){
			$this->error = "Invoice::addTaskActivities(): Invalid parameter!";
			return FALSE;
		}

		$clause = " WHERE a.id IN (".implode(',', $ta_ids).")";
		$ta = new TaskActivity();
		$tas = $ta->retrieveSet($clause);
		if($tas === FALSE){
			$this->error = "Invoice::addTaskActivities(): Error getting activities: ".$ta->getLastError();
			return FALSE;
		}

		$tas_count = count($tas);
		$lines = array();
		for($i=0; $i<$tas_count; $i++){

			// Aggregate by task
			if(isset($lines[$tas[$i]->task_id]) && $lines[$tas[$i]->task_id]->unit_price == $tas[$i]->hourly_rate){
				$lines[$tas[$i]->task_id]->quantity = round($lines[$tas[$i]->task_id]->quantity + ($tas[$i]->end_ts - $tas[$i]->start_ts) / 60 /60, 2);
				$ill = new InvoiceLineLink();
				$ill->task_activity_id = $tas[$i]->id;
				$lines[$tas[$i]->task_id]->_links[] = $ill;
			}else{
				if($tas[$i]->getTask() === FALSE){
					$this->error = "Invoice::addTaskActivities(): Error getting task for activity: ".$tas[$i]->getLastError();
					return FALSE;
				}

				if($tas[$i]->_task->getProject() === FALSE){
					$this->error = "Invoice::addTaskActivities(): Error getting project for activity: ".$tas[$i]->getLastError();
					return FALSE;
				}
				$il = new InvoiceLine();
				$il->invoice_id = $this->id;
				$il->quantity = round(($tas[$i]->end_ts - $tas[$i]->start_ts) / 60 /60, 2);
				$il->unit_price = $tas[$i]->hourly_rate;
				$il->description = $tas[$i]->_task->_project->name.": ".$tas[$i]->_task->name;
				$ill = new InvoiceLineLink();
				$ill->task_activity_id = $tas[$i]->id;
				$il->_links[] = $ill;
				$lines[$tas[$i]->task_id] = $il;
			}
		}

		if(!$this->_lines)
			$this->_lines = array();
			
		foreach($lines as $line){
			if($line->add() === FALSE){
				$this->error = "Invoice::addTaskActivities(): Error adding line item: ".$line->getLastError();
				return FALSE;
			}
			$this->_lines[] = $line;
		}

		return TRUE;
	}

	function addPaymentSchedules($ps_ids){
		if(!is_array($ps_ids) || count($ps_ids) <= 0){
			$this->error = "Invoice::addPaymentSchedules(): Invalid parameter!";
			return FALSE;
		}

		$clause = " WHERE id IN (".implode(',', $ps_ids).")";
		$ps = new PaymentSchedule();
		$ps_items = $ps->retrieveSet($clause);
		if($ps_items === FALSE){
			$this->error = "Invoice::addPaymentSchedules(): Error getting payment schedules: ".$ps->getLastError();
			return FALSE;
		}

		$ps_count = count($ps_items);
		$lines = array();
		for($i=0; $i<$ps_count; $i++){
			if($ps_items[$i]->getProject() === FALSE){
				$this->error = "Invoice::addPaymentSchedules(): Error getting project for payment schedule: ".$tas[$i]->getLastError();
				return FALSE;
			}
			$il = new InvoiceLine();
			$il->invoice_id = $this->id;
			$il->quantity = 1;
			$il->unit_price = $ps_items[$i]->amount;
			$il->description = $ps_items[$i]->_project->name.": ".$ps_items[$i]->description;
			$ill = new InvoiceLineLink();
			$ill->payment_schedule_id = $ps_items[$i]->id;
			$il->_links[] = $ill;
			$lines[] = $il;
		}

		if(!$this->_lines)
			$this->_lines = array();
			
		foreach($lines as $line){
			if($line->add() === FALSE){
				$this->error = "Invoice::addPaymentSchedules(): Error adding line item: ".$line->getLastError();
				return FALSE;
			}
			$this->_lines[] = $line;
		}

		return TRUE;
	}

	function addExpenses($expense_ids){
		if(!is_array($expense_ids) || count($expense_ids) <= 0){
			$this->error = "Invoice::addExpenses(): Invalid parameter!";
			return FALSE;
		}

		$clause = " WHERE e.id IN (".implode(',', $expense_ids).")";
		$exp = new Expense();
		$expenses = $exp->retrieveSet($clause);
		if($expenses === FALSE){
			$this->error = "Invoice::addExpenses(): Error getting expenses: ".$exp->getLastError();
			return FALSE;
		}

		$expense_count = count($expenses);
		$lines = array();
		for($i=0; $i<$expense_count; $i++){
			$il = new InvoiceLine();
			$il->invoice_id = $this->id;
			$il->quantity = 1;
			$il->unit_price = $expenses[$i]->price;
			$il->description = $expenses[$i]->description;
			$ill = new InvoiceLineLink();
			$ill->expense_id = $expenses[$i]->id;
			$il->_links[] = $ill;
			$lines[] = $il;
		}

		if(!$this->_lines)
			$this->_lines = array();
			
		foreach($lines as $line){
			if($line->add() === FALSE){
				$this->error = "Invoice::addExpenses(): Error adding line item: ".$line->getLastError();
				return FALSE;
			}
			$this->_lines[] = $line;
		}

		return TRUE;
	}

	function addCustomLines($custom_lines){
		if(!is_array($custom_lines) || count($custom_lines) <= 0){
			return TRUE;
		}

		$lines = array();
		foreach($custom_lines as $new_line){
			if(!isset($new_line['quantity']) || !isset($new_line['description']) || !isset($new_line['price']))
				continue;
				
			if($new_line['quantity'] <= 0)
				continue;
				
			$il = new InvoiceLine();
			$il->invoice_id = $this->id;
			$il->quantity = $new_line['quantity'];
			$il->unit_price = $new_line['price'];
			$il->description = $new_line['description'];
			$lines[] = $il;
		}

		if(!$this->_lines)
			$this->_lines = array();
			
		foreach($lines as $line){
			if($line->add() === FALSE){
				$this->error = "Invoice::addCustomLines(): Error adding line item: ".$line->getLastError();
				return FALSE;
			}
			$this->_lines[] = $line;
		}

		return TRUE;
	}

	function getTotal(){
		$total_price =  0.00;

		for($i = 0; $i < count($this->_lines); $i++){
			$total_price += $this->_lines[$i]->getTotal();
		}

		return round($total_price, 2);
	}

	function getAmountDue(){
		global $db_conn;

		$result = $db_conn->query("SELECT SUM(pi.amount) as amount_paid
FROM payment_invoices AS pi 
WHERE pi.invoice_id = '{$this->id}'
GROUP BY pi.invoice_id
");

		if(!$result){
			$this->error = "Invoice::getOutstanding(): ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		$amount_paid = 0.00;
		if($row=$result->fetchRow()){
			$amount_paid = $row[0];
		}
		
		return $this->getTotal() - $amount_paid;
	}

	function getOutstanding($company_id = 0){
		global $db_conn;

		$company_id = intval($company_id);
		if($company_id > 0){
			$c_id_clause = " WHERE it.company_id = $company_id ";
		}
		
$sql1 = "CREATE TEMPORARY TABLE invoice_totals 
SELECT i.id, i.company_id, ROUND(SUM(il.quantity * il.unit_price),2) AS total
FROM invoices AS i
LEFT JOIN invoice_lines AS il ON i.id = il.invoice_id
GROUP BY i.id
ORDER BY i.id
";

$sql2 = "SELECT i.id, i.company_id, i.address1, i.address2, i.city, i.state,
i.zip, i.timestamp, i.terms, i.trans_id, it.total, 
ROUND(SUM(pi.amount),2) AS amount_paid
FROM invoices AS i
LEFT JOIN payment_invoices AS pi ON pi.invoice_id = i.id
LEFT JOIN invoice_totals AS it ON it.id = i.id
$c_id_clause
GROUP BY i.id
HAVING amount_paid IS NULL OR (total - amount_paid) > 0
ORDER BY i.timestamp;
";

		$result = $db_conn->query($sql1);
		if(!$result){
			$this->error = "Invoice::getOutstanding(): Phase 1 Error: ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		$result = $db_conn->query($sql2);
		if(!$result){
			$this->error = "Invoice::getOutstanding(): Phase 2 Error: ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		while($row=$result->fetchRow()){
			$temp =& new Invoice();
			$temp->_populateData($row);
			$temp->amount_paid = $row[11];
			$temp->_populateLines();
			$invoices[] =& $temp;
		}

		return $invoices;
	}

	function getName(){
    	$company = new Company();
    	if($company->get($this->company_id) === FALSE){
	      $this->error = "Company::getName(): Error getting company: ".$company->getLastError();
    	  return "";
    	}

    	return $company->name;
	}

	function getCompany(){
		if(!$this->_company && $this->company_id > 0){
			$this->_company = new Company();
			if($this->_company->get($this->company_id) === FALSE){
				$this->error = "Error retreiving company information: ".$this->_company->getLastError();
				return FALSE;
			}
		}
		
		return $this->_company;	
	}
	  	
  	function getPDF(){
		if(!is_array($this->_lines) || count($this->_lines) == 0){
			$this->error = "Invoice has no line items.";
			return FALSE;
		}
		
		$company =& $this->getCompany();
		$company_info = $GLOBALS['invoice_text'];
		
		$client_info = array();
		$client_info['name'] = $company->name;
		$client_info['address1'] = $company->address1;
		$client_info['address2'] = $company->address2;
		$client_info['address3'] = $company->city.", ".$company->state."  ".$company->zip;
		$client_info['phone1'] = $company->phone;
		$client_info['fax'] = $company->fax;
		
		$line_items = array();
		$line_index = 0;
		foreach($this->_lines as $line){
			$line_items[$index]['quantity'] = $line->quantity;
			$line_items[$index]['description'] = $line->description;
			$line_items[$index]['unit_price'] = number_format($line->unit_price, 2);
			$line_items[$index]['total'] = number_format($line->getTotal(),2);
			$index++;
		}
		
		$inv_pdf = new PDFInvoice($this->id, $company_info, $client_info, $line_items, 'NET15', $this->timestamp);
		$pdf_file = $inv_pdf->get_invoice_pdf();
		if($pdf_file === FALSE){
			$this->error = "Error creating invoice PDF: ".$inv_pdf->error;
			return FALSE;
		}
  			
		return $pdf_file;
  	}
  	
	function getNotificationParams(){
		global $loggedin_user;

		$params = $GLOBALS['invoice_text'];
		$params['company_name'] = $params['name'];
		$params['company_phone'] = $params['phone1'];
		
		$company =& $this->getCompany();
		if($company === FALSE)
			return FALSE;
		
		$params['invoice_emails'] = $company->getInvoiceEmails();
		if($params['invoice_emails'] === FALSE){
			$this->error = "Invoice::getNotificationParams(): Error getting invoice emails: ".$company->getLastError();
			return FALSE;	
		}
		
		return $params;
	}

	function sendEmail(){
		$notif = new Notification();
		$params = $this->getNotificationParams();
		if(!isset($params['invoice_emails']) || empty($params['invoice_emails']))
			return TRUE;
			
		if($notif->getByName('InvoiceEmail') === FALSE){
			$this->error = "Invoice::sendEmail() : ".$notif->getLastError()."\n";
			return FALSE;
		}
		if($notif->prepare($params) === FALSE){
			$this->error = "Invoice::sendEmail() : ".$notif->getLastError()."\n";
			return FALSE;
		}
		
		// Setup attachment
		$pdf_file = $this->getPDF();
		if($pdf_file === FALSE)
			return FALSE;
			
		$attachments[0]['data'] = $pdf_file;
		$attachments[0]['name'] = 'invoice.pdf';
		$attachments[0]['type'] = 'application/pdf';
		$attachments[0]['encoding'] = 'base64';
		if($notif->send($attachments) === FALSE){
			$this->error = "Invoice::sendEmail() : ".$notif->getLastError()."\n";
			return FALSE;
		}

		// Update sent_ts
		$this->sent_ts = time();
		if($this->update() === FALSE){
			$this->error = "Invoice::sendEmail(): Email sent, error updating sent timestamp: ".$this->getLastError();
			return FALSE;	
		}
		
		return TRUE;
	}
  	
// END - Custom Invoice methods
////////////////////////////////////////////////////////////
}

