<?

////////////////////////////////////////////////////////////
// Code generated by CodeGen (http://uversaconsulting.net).
// Insert custom code where indicated below.
////////////////////////////////////////////////////////////

// Payment Class Definition 
////////////////////////////////////////////////////////////
class Payment{
	var $id, $company_id, $timestamp, $amount, 
	  $type, $check_no, $auth_code, $trans_id;

	var $error;

	function Payment(){
		$this->error = '';
		$this->id = 0;
		$this->company_id = 0;
		$this->timestamp = time();
		$this->amount = 0;
		$this->type = '';
		$this->check_no = 0;
		$this->auth_code = '';
		$this->trans_id = 0;

	}

	function _populateData($values){
		if(is_array($values)){
			$this->id = $values[0];
			$this->company_id = $values[1];
			$this->timestamp = $values[2];
			$this->amount = $values[3];
			$this->type = $values[4];
			$this->check_no = $values[5];
			$this->auth_code = $values[6];
			$this->trans_id = $values[7];
		}
	}


	function updateFromAssocArray($array){
		if(is_array($array)){
			foreach($array as $key => $value)
				$this->$key = $value;
		}
	}

	function escapeStrings(){
		global $db_conn;
		
		$vars = get_object_vars($this);
		foreach($vars as $key => $value){
			if(is_string($value)){
				$this->$key = $db_conn->escapeString($value);
			}
		}
	}

	function stripSlashes(){
		$vars = get_object_vars($this);
		foreach($vars as $key => $value){
			if(is_string($value)){
				$this->$key = stripcslashes($value);
			}
		}
	}

	function getLastError(){
		return $this->error;
	}

	function add(){
		global $db_conn;

		$this->escapeStrings();
		$result = $db_conn->query("INSERT INTO payments (company_id, timestamp, amount, type, ".
		  "check_no, auth_code, trans_id)".
		  " VALUES(".$this->company_id.", ".$this->timestamp.", ".$this->amount.", '".$this->type."', ".
		  "".$this->check_no.", '".$this->auth_code."', ".$this->trans_id.")");
		$this->stripSlashes();
		if($result){
			$this->id = mysql_insert_id();
			return TRUE;
		}else{
			$this->error = "Payment::add() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function update(){
		global $db_conn;

		if(!isset($this->id)){
			$this->error = "Payment::update() : Payment id not set\n";
			return FALSE;
		}

		$this->escapeStrings();
		$result = $db_conn->query("UPDATE payments SET company_id = ".$this->company_id.", ".
		  "timestamp = ".$this->timestamp.", amount = ".$this->amount.", ".
		  "type = '".$this->type."', check_no = ".$this->check_no.", ".
		  "auth_code = '".$this->auth_code."', trans_id = ".$this->trans_id."".
		  " WHERE id = ".$this->id."");
		$this->stripSlashes();
		if($result){
			return TRUE;
		}else{
			$this->error = "Payment::update() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function delete($id = NULL){
		global $db_conn;

		if(!isset($id)){
			$id = $this->id;
		}

		if(!isset($id)){
			$this->error = "Payment::delete() : Payment id not set\n";
			return FALSE;
		}

		$result = $db_conn->query("DELETE FROM payments WHERE id = $id");

		if($result){
			return TRUE;
		}else{
			$this->error = "Payment::delete() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function get($id = NULL){
		global $db_conn;

		if(!isset($id)){
			$id = $this->id;
		}

		if(!isset($id)){
			$this->error = "Payment::get() : Payment id not set\n";
			return FALSE;
		}

		$Payment = Payment::retrieveSet("WHERE id = $id", TRUE);
		if($Payment === FALSE){
			return FALSE;
		}

		if(isset($Payment[0])){
			$this->updateFromAssocArray($Payment[0]);
			$this->stripSlashes();
			if($this->_populateInvoices() === FALSE)
				return FALSE;
		}else{
			$this->error = "Payment::get() : No data retrieved from query\n";
			return FALSE;
		}
		return TRUE;
	}

	function retrieveSet($clause = '', $raw = FALSE){
		global $db_conn;

		if(!empty($clause)){
			$clause = trim($clause);
			if(strlen($clause) > 5){
				if(strtolower(substr($clause, 0, 5)) != "where" && strtolower(substr($clause, 0, 5)) != "order")
					$clause = "WHERE ".$clause;
			}else{
				$clause = "WHERE ".$clause;
			}
		}

		$result = $db_conn->query("SELECT  id, company_id, timestamp, amount, type, check_no, ".
		  "auth_code, trans_id".
		  " FROM payments ".$clause);

		if($result === FALSE){
			$this->error = "Payment::retrieveSet(): ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		while($row=$result->fetchArray(MYSQL_ASSOC)){
			if($raw == TRUE){
				$Payment[] = $row;
			}else{
				$temp =& new Payment();
				$temp->updateFromAssocArray($row);
				$temp->stripSlashes();
				if($temp->_populateInvoices() === FALSE)
					return FALSE;
				$Payment[] =& $temp;
			}

		}

		return $Payment;
	}
// BEGIN - Custom Payment methods 
////////////////////////////////////////////////////////////
	var $_invoice_ids;

	function _populateInvoices(){
		global $db_conn;

		$this->_invoice_ids = array();
		if($this->id <= 0)
			return TRUE;

		$sql = "SELECT invoice_id,amount FROM payment_invoices WHERE payment_id = {$this->id}";
		$result = $db_conn->query($sql);
		if($result === FALSE){
			$this->error = "Payment::_populateInvoices(): Error getting invoice IDs: ".$db_conn->getLastError();
			return FALSE;
		}

		while($row = $result->fetchArray(MYSQL_ASSOC)){
			$this->_invoice_ids[$row['invoice_id']] = $row['amount'];
		}

		return TRUE;
	}

	function onInvoice($invoice_id){
		if(isset($this->_invoice_ids[$invoice_id]))
			return TRUE;

		return FALSE;
	}

	function getAmountForInvoice($invoice_id){
		if(isset($this->_invoice_ids[$invoice_id]))
			return $this->_invoice_ids[$invoice_id];

		return 0.00;
	}

	function getTypeSelectTags($selected = NULL){
		$tags = "";

		$options = array( 'CHECK' => 'CHECK', 'CC' => 'CC', 'CASH' => 'CASH' );

		foreach($options as $value => $name){
			$sel_text = "";
			if($value==$selected)
				$sel_text = " SELECTED";

			$tags .= "<OPTION VALUE=\"".$value."\"".$sel_text.">".$name." ".$row[2]."</OPTION>\n";
		}
		return $tags;
	}


	function attachInvoices($invoices, $append = FALSE){
		global $db_conn;

		if(!$append)
			if($this->clearInvoices() === FALSE)
				return FALSE;

		if(count($invoices) == 0)
			return TRUE;

		$this->id = intval($this->id);
		foreach($invoices as $id => $amount){
			$id = intval($id);
			if($db_conn->query("INSERT INTO payment_invoices SET invoice_id = $id, payment_id = {$this->id}, amount = '$amount'") === FALSE){
				$this->error = "Payment::attachInvoices(): Error adding invoice: ".$db_conn->getLastError();
				return FALSE;
			}
		}

		return TRUE;
	}

	function clearInvoices(){
		global $db_conn;

		$this->id = intval($this->id);
		if($db_conn->query("DELETE FROM payment_invoices WHERE payment_id = {$this->id}") === FALSE){
			$this->error = "Payment::clearInvoices(): Error removing invoices: ".$db_conn->getLastError();
			return FALSE;
		}

		return TRUE;
	}

	function getForInvoice($invoice_id){
		global $db_conn;

		$result = $db_conn->query("SELECT p.id, p.company_id, p.timestamp, p.amount, p.type, p.check_no, ".
		  "p.auth_code, p.trans_id".
		  " FROM payments AS p
			LEFT JOIN payment_invoices AS pi ON pi.payment_id = p.id
			WHERE pi.invoice_id = '$invoice_id'");

		if($result === FALSE){
			$this->error = "Payment::getForInvoice(): ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		while($row=$result->fetchArray(MYSQL_ASSOC)){
			$temp =& new Payment();
			$temp->updateFromAssocArray($row);
			$temp->stripSlashes();
			if($temp->_populateInvoices() === FALSE)
				return FALSE;
			$Payment[] =& $temp;
		}

		return $Payment;
	}
// END - Custom Payment methods
////////////////////////////////////////////////////////////
}
