<?

function selected($var1, $var2){
	if(is_array($var1) && in_array($var2, $var1)){
		return ' selected ';
	}else if(is_array($var2) && in_array($var1, $var2)){
		return ' selected ';
	}else	if($var1 === $var2){
		return ' selected ';
	}
	return '';
}

function checked($var1, $var2){
	//var_dump($var1, "\nCHECKING\n", $var2);
	if(is_array($var1) && in_array($var2, $var1)){
		return ' checked ';
	}else if(is_array($var2) && in_array($var1, $var2)){
		print("var2 is an array and checked");
		return ' checked ';
	}else	if($var1 === $var2){
		return ' checked ';
	}
	return '';
}

// Method to get string with option tags 
// for each state.
//
// Params:	$state = abbreviation of state to be selected
//
// Returns: String or NULL on error
//
function getStateTags($state = 'AZ'){
	$stateAbrv = array("AL", "AK", "AZ", "AR", "CA", "CO", "CT", "DE", "DC",
		"FL", "GA", "HI", "ID", "IL", "IN", "IA", "KS", "KY", "LA", "ME", "MD",
		"MA", "MI", "MN", "MS", "MO", "MT", "NE", "NV", "NH", "NJ", "NM", "NY",
		"NC", "ND", "OH", "OK", "OR", "PA", "RI", "SC", "SD", "TN", "TX", "UT",
		"VT", "VA", "WA", "WV", "WI", "WY");
	$stateName = array("Alabama", "Alaska", "Arizona", "Arkansas", "California",
		"Colorado", "Connecticut", "Delaware", "Dist. Of Columbia", "Florida", "Georgia",
		"Hawaii", "Idaho", "Illinois", "Indiana", "Iowa", "Kansas", "Kentucky", "Louisiana",
		"Maine", "Maryland", "Massachusetts", "Michigan", "Minnesota", "Mississippi", "Missouri",
		"Montana", "Nebraska", "Nevada", "New Hampshire", "New Jersey", "New Mexico", "New York",
		"North Carolina", "North Dakota", "Ohio", "Oklahoma", "Oregon", "Pennsylvania", 
		"Rhode Island", "South Carolina", "South Dakota", "Tennessee", "Texas", "Utah", "Vermont",
		"Virginia", "Washington", "West Virginia", "Wisconsin", "Wyoming");

	for($i = 0; $i < count($stateAbrv); $i++){
		if($state == $stateAbrv[$i]){
			$states .= "<option value='".$stateAbrv[$i]."' selected>".$stateName[$i]."</option>\n";
		}else{
			$states .= "<option value='".$stateAbrv[$i]."'>".$stateName[$i]."</option>\n";
		}
	}
	return $states;
}

// Method to strip one paramter from
// the a query string
//
// Params:	$param = parameter name
//
// Returns: String or NULL on error
//
function stripGetParam($param, $param2 = ''){
	global $_GET;
	$string = "?";
	foreach($_GET as $key => $value){
		if($key != $param && $key != $param2){
			$string .= $key."=".$value."&";
		}
	}
	return $string;
}

// Method to convert an Array to a string
// of comma seperated values
//
// Params:   $array = Array
//
// Returns:  String on NULL on error
//
function arrayToString($array){
	if(!is_array($array)){
		return NULL;
	}
	
	$numValues = count($array);
	for($i = 0; $i < $numValues; $i++){
		if($i == ($numValues-1)){
			$string .= $array[$i];
		}else{
			$string .= $array[$i].", ";
		}
	}
	
	return $string;
	
}

// Method to display error messages
//
// Params:		$msg - Message to display
//						$class - CSS Class
//
// Returns:		Error String or Empty String
function displayError($msg, $class){
	if(!$msg){
		return '';
	}else{
		return "\n<DIV CLASS=\"$class\">".nl2br($msg)."</DIV>\n";
	}
}

// Method returns NULL if variable is unset or = ''
// This should only be used on number variables
//
// Params:		$var - Variable to test
//
// Returns:		'NULL' if variable is not set
//
function numberOrNull($var){
	if(isset($var) && $var != ''){
		return $var;
	}else{
		return 'NULL';
	}
}

// Method formats a length of time based on 
// the number of seconds provided in $seconds
// 
// Params:		$seconds - length of time in seconds
//
// Returns:		'NULL' if variable is not set
//
function formatLengthOfTime($seconds){
	$hours = 0;
	$minutes = 0;
	
	if($seconds >= 3600){
		$hours = intval($seconds / 3600);
		$seconds = intval($seconds - ($hours * 3600));
	}
  if($seconds >= 60){
		$minutes = intval($seconds / 60);
		$seconds = intval($seconds - ($minutes * 60));
	}
	
	$text = $hours.":".sprintf("%02d", $minutes);
	return $text;
}

// Method to generate a password using just lowercase letters
//
// Params:		$length - length of generated password
//
// Returns:		String
//
function make_password($length){
    $vowels = 'aeiouy';
    $consonants = 'bdghjlmnpqrstvwxz';
    $password = '';
    
    $alt = time() % 2;
    srand(time());

    for ($i = 0; $i < $length; $i++) {
        if ($alt == 1) {
            $password .= $consonants[(rand() % 17)];
            $alt = 0;
        } else {
            $password .= $vowels[(rand() % 6)];
            $alt = 1;
        }
    }
    return $password;
}

function getDateSelector($timestamp, $name, $showTime = FALSE,  $id = NULL, $tabindex = NULL, $js_onchange = NULL){
	if($timestamp > 0){
		$now = localtime($timestamp);
		$month = ($now[4] + 1);
		$year = ($now[5] + 1900);
		$day = $now[3];
		$hour = $now[2];
		$minute = $now[1];
		$date = $month."/".$day."/".$year;
		$time = sprintf("%02d:%02d", $hour, $minute);
	}else{
		$now = localtime();
		$month = ($now[4] + 1);
		$year = ($now[5] + 1900);
		$day = $now[3];
		$hour = $now[2];
		$minute = $now[1];
		$time = "00:00";
		$date = "";
	}

	$tabindex_html = '';
	if(!is_null($tabindex))
		$tabindex_html = ' tabindex="'.$tabindex.'"';

	$js_onchange_html = '';
	if(!is_null($js_onchange))
		$js_onchange_html = ' onChange="'.$js_onchange.'"';

	if(is_null($id))
		$id = $name;

	static $header = FALSE;
	$ds_code = '';

	if(!$header){
		$ds_code .= '<script src="includes/browserSniffer.js" type="text/javascript" language="javascript"></script>
	<script src="includes/dynCalendar.js" type="text/javascript" language="javascript"></script>';
		$header = TRUE;
	}

	$ds_code .= '<script type="text/javascript">
		function calendarCallback_'.$id.'(date, month, year){
			document.getElementById("ds_'.$id.'").value = month + \'/\' + date + \'/\' + year;
			'.(!is_null($js_onchange) ? $js_onchange.';' : '').'
		}
	</script>';

	$ds_code .= '<input type="text" CLASS="input_text" name="ds_'.$name.'" id="ds_'.$id.'" value="'.$date.'" size="10"'.$tabindex_html.' '.$js_onchange_html.'>
	<script language="JavaScript" type="text/javascript">
			cal_'.$id.' = new dynCalendar("cal_'.$id.'", "calendarCallback_'.$id.'", "images/", "dynCalendarLayer_'.$id.'", '.$month.', '.$day.', '.$year.');
	 </script>';

	if($showTime){
		if(!is_null($tabindex))
			$tabindex_html = ' tabindex="'.($tabindex + 1).'"';

		$ds_code .= '&nbsp;&nbsp;<input type="text" CLASS="input_text" name="ds_time_'.$name.'" id="ds_time_'.$id.'" value="'.$time.'" size="6"'.$tabindex_html.'>(HH:MM 24-Hour Format)';
	}
	$ds_code .= '&nbsp;&nbsp;<A HREF="javascript:setCurrentTime(\''.$id.'\');" TITLE="Set Current Time"><IMG SRC="images/set_time.gif" WIDTH="16" HEIGHT="16" BORDER="0" ALT="Set Current Time"></A>';

 return $ds_code;

}

function getDateSelectorTS($name, $array_index = NULL){
	if(is_null($array_index))
		$date = $_REQUEST['ds_'.$name];
	else
		$date = $_REQUEST['ds_'.$name][$array_index];
	list($month, $day, $year) = split('[/\-]', $date);
	if(intval($month) > 0 && intval($day)>0 && intval($year)>0){
		$date = NULL;
		if(is_null($array_index))
			$date = $_REQUEST['ds_time_'.$name];
		else
			$date = $_REQUEST['ds_time_'.$name][$array_index];

		if(!empty($date)){
			list($hour,$min) = split(":", $date);
		}else{
			$hour = 0;
			$min = 0;
		}
		return mktime($hour, $min, 0, $month, $day, $year);
	}else{
		return 0;
	}
}

// Method to generate select fields for choosing a date
//
// Params: $timestamp - DateTime to be selected
//				 $prefix - field name prefix
//
// Returns: String
function getDateSelectorOld($timestamp, $prefix = ''){
	if($timestamp>0){
		$time = localtime($timestamp);
		$month = ($time[4] + 1);
		$year = ($time[5] + 1900);
		$day = $time[3];
		$hour = $time[2];
		$minute = $time[1];
	}

	//Build month tags
	$html = "&nbsp;<SELECT NAME='{$prefix}month'>\n<OPTION VALUE='0'></OPTION>\n";
	for($i = 1; $i <= 12; $i++){
		switch($i){
			case 1:
				$month_name = "Jan";
				break;
			case 2:
				$month_name = "Feb";
				break;
			case 3:
				$month_name = "Mar";
				break;
			case 4:
				$month_name = "Apr";
				break;
			case 5:
				$month_name = "May";
				break;
			case 6:
				$month_name = "Jun";
				break;
			case 7:
				$month_name = "Jul";
				break;
			case 8:
				$month_name = "Aug";
				break;
			case 9:
				$month_name = "Sep";
				break;
			case 10:
				$month_name = "Oct";
				break;
			case 11:
				$month_name = "Nov";
				break;
			case 12:
				$month_name = "Dec";
				break;
		} 
		$selected = "";
		if($i == $month)
			$selected = " SELECTED";
		$html .= "\t<OPTION VALUE='$i'".$selected.">$month_name</OPTION>\n";
	}
	$html .= "</SELECT>/\n";
	
	//Build day tags
	$html .= "<SELECT NAME='{$prefix}day'>\n<OPTION VALUE='0'></OPTION>\n";
	for($i = 1; $i <= 31; $i++){
		$selected = "";
		if($i == $day)
			$selected = " SELECTED";
		$html .= "\t<OPTION VALUE='$i'".$selected.">$i</OPTION>\n";
	}
	$html .= "</SELECT>/\n";

	//Build year tags
	$html .= "<SELECT NAME='{$prefix}year'>\n<OPTION VALUE='0'></OPTION>\n";
	for($i = 2000; $i <= 2010; $i++){
		$selected = "";
		if($i == $year)
			$selected = " SELECTED";
		$html .= "\t<OPTION VALUE='$i'".$selected.">$i</OPTION>\n";
	}
	$html .= "</SELECT>&nbsp;&nbsp;\n";

	//Build hour tags
	$html .= "<SELECT NAME='{$prefix}hour'>\n<OPTION VALUE='0'></OPTION>\n";
	for($i = 0; $i <= 23; $i++){
		$selected = "";
		if($i == $hour && $timestamp > 0)
			$selected = " SELECTED";
		$html .= "\t<OPTION VALUE='$i'".$selected.">$i</OPTION>\n";
	}
	$html .= "</SELECT>:\n";

	//Build minute tags
	$html .= "<SELECT NAME='{$prefix}minute'>\n<OPTION VALUE='0'></OPTION>\n";
	for($i = 0; $i <= 55; $i+=5){
		$selected = "";
		if($i <= $minute && $minute > $i-5)
			$selected = " SELECTED";
		$html .= "\t<OPTION VALUE='$i'".$selected.">".str_pad($i, 2, "0", STR_PAD_LEFT)."</OPTION>\n";
	}
	$html .= "</SELECT>&nbsp;&nbsp;\n";

	return $html;
}

function getDateSelectorTSOld($prefix = ""){
	if(intval($_REQUEST["{$prefix}hour"]) == 0 && intval($_REQUEST["{$prefix}minute"]) == 0 &&
		 intval($_REQUEST["{$prefix}month"]) == 0 && intval($_REQUEST["{$prefix}day"]) == 0 && intval($_REQUEST["{$prefix}year"]) == 0){
		return 0;
	}else{
		return mktime($_REQUEST["{$prefix}hour"], $_REQUEST["{$prefix}minute"], 0, $_REQUEST["{$prefix}month"], $_REQUEST["{$prefix}day"], $_REQUEST["{$prefix}year"]);
	}
}
?>