<?
require_once('includes/common.php');
checkLogin('admin');

require_once('includes/Notification.php');
$title = '';
$notification = new Notification();

if($_REQUEST['mode'] == 'add'){
	$title = "Add Notification";

	if($_POST['save']){
		$notification->updateFromAssocArray($_POST);
		if($notification->add()){
			if(!empty($_POST['new_address'])){
				if($notification->addAddress($_POST['new_address']) === FALSE){
					$error_msg .= "Error adding new address to notification!";
					debug_message($notification->getLastError());
				}
			}

			if(!empty($_POST['new_macro_name'])){
				if($notification->addMacro($_POST['new_macro_name'], $_POST['new_macro_description']) === FALSE){
					$error_msg .= "Error adding new macro to notification!";
					debug_message($notification->getLastError());
				}
			}

			if(empty($error_msg)){
				goBack();
			}

		}else{
			$error_msg .= "Error adding Notification!\n";
			debug_message($notification->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'edit'){
	$title = "Edit Notification";
	if(empty($_REQUEST['id'])){
		$error_msg .= "Error: No ID specified!\n";
	}else{
		if(!$notification->get($_REQUEST['id'])){
			$error_msg .= "Error retrieving notification information!\n";
			debug_message($notification->getLastError());
		}
	}

	if($_POST['save']){
		$notification->updateFromAssocArray($_POST);
		if($notification->update()){
			if(!empty($_POST['new_address'])){
				if($notification->addAddress($_POST['new_address']) === FALSE){
					$error_msg .= "Error adding new address to notification!";
					debug_message($notification->getLastError());
				}
			}

			if(!empty($_POST['new_macro_name'])){
				if($notification->addMacro($_POST['new_macro_name'], $_POST['new_macro_description']) === FALSE){
					$error_msg .= "Error adding new macro to notification!";
					debug_message($notification->getLastError());
				}
			}

			if(empty($error_msg)){
				goBack();
			}
		}else{
			$error_msg .= "Error updating Notification!\n";
			debug_message($notification->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'delete'){
	$title = "Delete Notification";

	if(!$notification->get($_REQUEST['id'])){
		$error_msg .= "Error retrieving notification information!\n";
		debug_message($notification->getLastError());
	}

	if($_POST['confirm']){
		if($_POST['confirm'] == "Yes"){
			if($notification->delete($_REQUEST['id'])){
				goBack();
			}else{
				$error_msg .= "Error deleting Notification!\n";
			}
		}else{
			goBack();
		}
	}
}else if($_REQUEST['mode'] == 'delete_address'){
	$title = "Delete Email Address";

	$na = new NotificationAddress();
	if($na->delete($_REQUEST['address_id'])){
		header("Location: ".$_SERVER['PHP_SELF']."?mode=edit&id=".$_REQUEST['id']."\r\n");
		exit();
	}else{
		$error_msg .= "Error deleting email address!\n";
		debug_message($na->getLastError());
	}
}else if($_REQUEST['mode'] == 'delete_macro'){
	$title = "Delete Notification Macro";

	$nm = new NotificationMacro();
	if($nm->delete($_REQUEST['macro_id'])){
		header("Location: ".$_SERVER['PHP_SELF']."?mode=edit&id=".$_REQUEST['id']."\r\n");
		exit();
	}else{
		$error_msg .= "Error deleting macro!\n";
		debug_message($nm->getLastError());
	}
}else{
	$title = "Invalid Mode";
	$error_msg .= "Error: Invalid mode!\n";
}

?>
<? require('header.php'); ?>
<FORM ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="POST">
<INPUT NAME="id" TYPE="hidden" VALUE="<?= $_REQUEST['id'] ?>">
<INPUT NAME="mode" TYPE="hidden" VALUE="<?= $_REQUEST['mode'] ?>">
<INPUT NAME="referrer" TYPE="hidden" VALUE="<?= $_REQUEST['referrer'] ?>">
<?if($_REQUEST['mode'] == "delete"){?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_cell">
		<BR>Are you sure you want to delete the Notification named <b><?= $notification->name ?></b>?<BR><BR>
		<SPAN CLASS="error">CAUTION:</SPAN>This action is irreversible.<BR><BR>
	</TD>
</TR>
<TR>
	<TD CLASS="form_footer_cell">
		<DIV ALIGN="center">
			<INPUT TYPE="submit" CLASS="button" NAME="confirm" VALUE="Yes">&nbsp;&nbsp;
			<INPUT TYPE="submit" CLASS="button" NAME="confirm" VALUE="No">
		</DIV>
	</TD>
</TR>
<?}else{?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Name:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="name" CLASS="input_text" SIZE="25" TYPE="text" VALUE="<?= $notification->name ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Description:</TD>
	<TD CLASS="form_field_cell"><TEXTAREA NAME="description" COLS="50" CLASS="input_text"><?= $notification->description ?></TEXTAREA></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">From Address:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="from_address" CLASS="input_text" SIZE="25" TYPE="text" VALUE="<?= $notification->from_address ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Subject:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="subject" CLASS="input_text" SIZE="45" TYPE="text" VALUE="<?= $notification->subject ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Email:</TD>
	<TD CLASS="form_field_cell"><TEXTAREA NAME="email" ROWS="20" COLS="50" CLASS="input_text"><?= $notification->email ?></TEXTAREA></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Active:</TD>
	<TD CLASS="form_field_cell">
		<INPUT NAME="active" TYPE="radio" VALUE="Y" <?= checked($notification->active, "Y") ?>>Yes&nbsp;
		<INPUT NAME="active" TYPE="radio" VALUE="N" <?= checked($notification->active, "N") ?>>No&nbsp;
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">E-Mail Addresses:</TD>
	<TD CLASS="form_field_cell">
<?  $nas = $notification->addresses;
		$na_count = count($nas);
		if($na_count > 0){
			for($i=0; $i<$na_count; $i++){ ?>
		<LI CLASS="taskitem"><?= $nas[$i]->address ?>&nbsp;&nbsp;
			<A HREF="<?= $_SERVER['PHP_SELF']."?id=".$notification->id."&mode=delete_address&address_id=".$nas[$i]->id ?>">
			<IMG SRC="images/delete_small.gif" BORDER="0" WIDTH="13" HEIGHT="13" ALIGN="middle"/></A>&nbsp;
		</LI>
<?  	}
		}else{?>
		<b>No Addresses Configured</b>
<?	} ?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Add Email Address:</TD>
	<TD CLASS="form_field_cell">
		<INPUT NAME="new_address" CLASS="input_text" SIZE="35" TYPE="text">
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Available Macros:</TD>
	<TD CLASS="form_field_cell">
<?  $nms = $notification->macros;
		$nm_count = count($nms);
		if($nm_count > 0){
			for($i=0; $i<$nm_count; $i++){ ?>
		<LI CLASS="taskitem"><?= $nms[$i]->name ?>&nbsp;&nbsp;-&nbsp;&nbsp;<?= $nms[$i]->description ?>
			<A HREF="<?= $_SERVER['PHP_SELF']."?id=".$notification->id."&mode=delete_macro&macro_id=".$nms[$i]->id ?>">
			<IMG SRC="images/delete_small.gif" BORDER="0" WIDTH="13" HEIGHT="13" ALIGN="middle"/></A>&nbsp;
		</LI>
<?  	}
		}else{?>
		<b>No Macros Configured</b>
<?	} ?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Add Macro:</TD>
	<TD CLASS="form_field_cell">
		<INPUT NAME="new_macro_name" CLASS="input_text" SIZE="20" TYPE="text"><BR>
		<INPUT NAME="new_macro_description" CLASS="input_text" SIZE="45" TYPE="text">
	</TD>
</TR>
<TR>
	<TD COLSPAN="2" CLASS="form_field_cell">
		<DIV ALIGN="right"><INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Save"></DIV>
	</TD>
</TR>
</TABLE>
<?} //if mode==delete?>
</FORM>
<? require('footer.php'); ?>